var LiveClickOptions =
{
	// Constants
	PREF_BASE : "extensions.liveclick.",

	// Initialization code
	onLoad : function (aDialogId)
	{
		var dialog = document.getElementById( aDialogId );
		if (!dialog) return;

		var aPrefs = dialog.getElementsByAttribute( "prefstring", "*" );
		if (!aPrefs) return;

		for (var i=0; i<aPrefs.length; i++)
		{
			var sID = aPrefs[i].getAttribute( "id" );
			var sLocal = aPrefs[i].localName;
			var sType = aPrefs[i].getAttribute( "preftype" );
			var sString = aPrefs[i].getAttribute( "prefstring" );
			var sDefault = aPrefs[i].getAttribute( "prefdefval" );
			if (!sDefault) sDefault = "";

			if (!sType)
			{
				if (sLocal == "textbox")
					sType = "string";
				else if (sLocal == "checkbox" || sLocal == "button")
					sType = "bool";
				else if (sLocal == "radiogroup" || sLocal == "menulist")
					sType = "int";
			}

			// Retrieve current value
			var sValue = this.getPreference( sString, sType, sDefault );

			// Update dialog to reflect current value
			if (sLocal == "checkbox" || sLocal == "button")
				aPrefs[i].checked = sValue;
			else
				aPrefs[i].value = sValue;
		}
	},

	// Processed after dialog accepted
	onOK : function (aDialogId)
	{
		var dialog = document.getElementById( aDialogId );
		if (!dialog) return;

		var aPrefs = dialog.getElementsByAttribute( "prefstring", "*" );
		if (!aPrefs) return;

		for (var i=0; i<aPrefs.length; i++)
		{
			var sLocal = aPrefs[i].localName;
			var sType = aPrefs[i].getAttribute( "preftype" );
			var sString = aPrefs[i].getAttribute( "prefstring" );

			if (!sType)
			{
				if (sLocal == "textbox")
					sType = "string";
				else if (sLocal == "checkbox" || sLocal == "button")
					sType = "bool";
				else if (sLocal == "radiogroup" || sLocal == "menulist")
					sType = "int";
			}

			var sValue;

			// Retrieve value from dialog
			if (sLocal == "checkbox" || sLocal == "button")
				sValue = aPrefs[i].checked;
			else
				sValue = aPrefs[i].value;

			this.setPreference( sString, sType, sValue );
		}

		return true;
	},

	getPreference : function (sString, sType, sDefault)
	{
		var service = Components.classes["@mozilla.org/preferences-service;1"].
						getService( Components.interfaces.nsIPrefService ).
						getBranch( "" );

		var sName = this.PREF_BASE + sString;
		var sValue = null;

		try
		{
			switch (sType)
			{
				case "bool":
					sValue = service.getBoolPref( sName );
					break;
				case "int":
					sValue = service.getIntPref( sName );
					break;
				default:
					sValue = service.getCharPref( sName );
					break;
			}
		}
		catch (e)
		{
			// Do Nothing
		}

		if (sValue == null) sValue = sDefault;

		return sValue;
	},

	setPreference : function (sString, sType, sValue)
	{
		var service = Components.classes["@mozilla.org/preferences-service;1"].
						getService( Components.interfaces.nsIPrefService ).
						getBranch( "" );

		var sName = this.PREF_BASE + sString;

		try
		{
			switch (sType)
			{
				case "bool":
					service.setBoolPref( sName, sValue );
					break;
				case "int":
					service.setIntPref( sName, sValue );
					break;
				default:
					service.setCharPref( sName, sValue );
					break;
			}
		}
		catch (e)
		{
			// Do Nothing
		}
	},
}
